
#include <mysql/mysql.h>
#include <sys/time.h>
#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#include <string.h>

#include "defs.h"
#include "db.h"

#define MYSQL_SERVER	"localhost"
#define MYSQL_USER	"root"
#define MYSQL_PASSWD	""

MYSQL mysql;
extern client_info client;

int init_db()
{
	mysql_init(&mysql);
}

int register_user(msg_login * msg, unsigned long ip)
{

	int state;

	MYSQL *connection;
	MYSQL_RES *result;
	MYSQL_ROW row;
	char s[100];

	connection = mysql_real_connect(&mysql, MYSQL_SERVER, MYSQL_USER, MYSQL_PASSWD, "gnomemsg", 0, 0, 0);

	if (connection == NULL) {
		printf("%s\n", mysql_error(&mysql));
		mysql_close(connection);
		return -1;
	}

	sprintf(s, "SELECT passwd,status FROM users where login_id='%s'",
		msg->login);

//	printf("%s\n",s);
	state = mysql_query(connection, s);

	if (state != 0) {
		printf("%s\n", mysql_error(connection));
		mysql_close(connection);
		return -1;
	}

	result = mysql_store_result(connection);

	if (mysql_num_rows(result) == 0) {
		printf("NULL result.\n");
		mysql_close(connection);
		return -1;
	}

	row = mysql_fetch_row(result);
	mysql_free_result(result);

	if (strcmp(msg->passwd, row[0]) != 0) {
		printf("%s ==> Bad Password.\n", msg->login);
		mysql_close(connection);
		return -1;
	}

	if (atoi(row[1]) > 0) {
		printf("%s ==> User already logged on.\n", msg->login);
		mysql_close(connection);
		return -1;
	}

	sprintf(s,
		"UPDATE users SET ip=%u, status='%d', port=%d WHERE login_id='%s'",
		ip, msg->status, msg->port, msg->login);

//      printf("%s\n",s);
	state = mysql_query(connection, s);

	if (state != 0) {
		printf("%s\n", mysql_error(connection));
		mysql_close(connection);
		return -1;
	}

	mysql_close(connection);
	return 1;

}

int get_ip(char *name, msg_quser * msg)
{

	int state;

	MYSQL *connection;
	MYSQL_RES *result;
	MYSQL_ROW row;
	char s[100];

	sprintf(s,
		"SELECT ip, status, port FROM users where login_id='%s'",
		name);

//      printf("%s\n",s);

	connection = mysql_real_connect(&mysql, MYSQL_SERVER, MYSQL_USER, MYSQL_PASSWD, "gnomemsg", 0, 0, 0);
	state = mysql_query(connection, s);

	if (state != 0) {
		printf("%s\n", mysql_error(connection));
		mysql_close(connection);
		return -1;
	}

	result = mysql_store_result(connection);

	if (mysql_num_rows(result) == 0) {
		printf("NULL result.\n");
		mysql_close(connection);
		return -1;
	}

	row = mysql_fetch_row(result);

	msg->ip = atol(row[0]);
	msg->status = atoi(row[1]);
	msg->port = atoi(row[2]);

      //printf("%s is on port %d with Status : %d", name, msg->port, msg->status);

	mysql_free_result(result);
	mysql_close(connection);

	return 0;
}

list_uinfo *get_uinfo(msg_uinfo * msg)
{

	int state = 0;
	char s[200];
	int count;

	MYSQL *connection;
	MYSQL_RES *result;
	MYSQL_ROW row;

	list_uinfo *info_ptr = (list_uinfo *) malloc(sizeof(list_uinfo));
	list_uinfo *ptr = info_ptr;

	if (msg->mask == 0) {
		printf("NULL search criteria.\n");
		return NULL;
	}
	strcpy(s,
	       "SELECT login_id, name, age, sex, designation, department, expertise, status FROM users WHERE");

	if (msg->mask & SEARCH_LOGIN) {

		sprintf(s, "%s%s login_id='%s'", s, (state) ? " AND " : "",
			msg->info.login);
		state = 1;
	}

	if (msg->mask & SEARCH_NAME) {
		sprintf(s, "%s%s name='%s'", s, (state) ? " AND " : "",
			msg->info.name);
		state = 1;
	}

	if (msg->mask & SEARCH_AGE) {
		sprintf(s, "%s%s age='%d'", s, (state) ? " AND " : "",
			msg->info.age);
		state = 1;
	}

	if (msg->mask & SEARCH_SEX) {
		sprintf(s, "%s%s sex='%c'", s, (state) ? " AND " : "",
			msg->info.sex);
		state = 1;
	}

	if (msg->mask & SEARCH_DESG) {
		sprintf(s, "%s%s designation='%s'", s,
			(state) ? " AND " : "", msg->info.desg);
		state = 1;
	}

	if (msg->mask & SEARCH_DEPT) {
		sprintf(s, "%s%s department='%s'", s,
			(state) ? " AND " : "", msg->info.dept);
		state = 1;
	}

	if (msg->mask & SEARCH_EXPT) {
		sprintf(s, "%s%s expertise='%s'", s,
			(state) ? " AND " : "", msg->info.expt);
		state = 1;
	}

	if (msg->mask & SEARCH_STATUS) {
		sprintf(s, "%s%s status != 0", s, (state) ? " AND " : "");
		state = 1;
	}
//      printf("%s\n", s);

	connection = mysql_real_connect(&mysql, MYSQL_SERVER, MYSQL_USER, MYSQL_PASSWD, "gnomemsg", 0, 0, 0);
	state = mysql_query(connection, s);

	if (state != 0) {
		printf("%s\n", mysql_error(connection));
		mysql_close(connection);
		return NULL;
	}

	result = mysql_store_result(connection);

	count = mysql_num_rows(result);

	if (count == 0 || count > 255) {
		printf("NULL result or too many results.\n");
		mysql_close(connection);
		return NULL;
	}

	while (count--) {
		row = mysql_fetch_row(result);

		strcpy(ptr->info.login, row[0]);
		strcpy(ptr->info.name, row[1]);
		ptr->info.age = (row[2]) ? atoi(row[2]) : 0;
		ptr->info.sex = (row[3]) ? row[3][0] : 0;
		strcpy(ptr->info.desg, row[4]);
		strcpy(ptr->info.dept, row[5]);
		strcpy(ptr->info.expt, row[6]);
		ptr->info.status = atoi(row[7]);

		if (count) {
			ptr->next = (struct list_uinfo *)
			    malloc(sizeof(list_uinfo));
			ptr = (list_uinfo *) ptr->next;
		}
	}

	ptr->next = NULL;

	mysql_free_result(result);
	mysql_close(connection);

	return (info_ptr);
}

list_notify *get_notify(char *name)
{

	int state;
	MYSQL *connection;
	MYSQL_RES *result;
	MYSQL_ROW row;
	char s[200];
	int count;

	list_notify *list_ptr;
	list_notify *ptr;

	sprintf(s,
		"SELECT a.login_id, a.ip, a.status, a.port FROM users a, notify b where a.login_id=b.notify_user AND b.user='%s' AND a.status != 0",
		name);

//      printf("%s\n",s);

	connection = mysql_real_connect(&mysql, MYSQL_SERVER, MYSQL_USER, MYSQL_PASSWD, "gnomemsg", 0, 0, 0);
	state = mysql_query(connection, s);

	if (state != 0) {
		printf("%s\n", mysql_error(connection));
		mysql_close(connection);
		return NULL;
	}

	result = mysql_store_result(connection);

	count = mysql_num_rows(result);

	if (count == 0) {
		mysql_close(connection);
		return NULL;
	}

	list_ptr=(list_notify *) malloc(sizeof(list_notify));
	ptr=list_ptr;

	while (count--) {

		row = mysql_fetch_row(result);

		strcpy(ptr->client.login, row[0]);
		ptr->client.ip = atol(row[1]);
		ptr->client.status = atoi(row[2]);
		ptr->client.port = atoi(row[3]);

		if (count) {

			ptr->next = (struct list_notify *)
			    malloc(sizeof(list_notify));
			ptr = (list_notify *) ptr->next;
		}

	}

	ptr->next = NULL;

	mysql_free_result(result);

	mysql_close(connection);
	return (list_ptr);
}

int status_change(char *name, char status)
{
	int state;

	MYSQL *connection;
	MYSQL_RES *result;
	MYSQL_ROW row;
	char s[100];

	sprintf(s,
		"UPDATE users SET status='%d' WHERE login_id='%s'", status,
		name);

//      printf("%s\n",s);

	connection = mysql_real_connect(&mysql, MYSQL_SERVER, MYSQL_USER, MYSQL_PASSWD, "gnomemsg", 0, 0, 0);
	state = mysql_query(connection, s);

	if (state != 0) {
		printf("%s\n", mysql_error(connection));
		mysql_close(connection);
		return -1;
	}

	mysql_close(connection);
	return 1;

}

int add_notify(char *notify_user, char *user)
{
	int state;

	MYSQL *connection;
	MYSQL_RES *result;
	MYSQL_ROW row;
	char s[100];

	sprintf(s,
		"INSERT INTO notify VALUES ('%s', '%s')", user,
		notify_user);

//      printf("%s\n",s);

	connection = mysql_real_connect(&mysql, MYSQL_SERVER, MYSQL_USER, MYSQL_PASSWD, "gnomemsg", 0, 0, 0);

	if(!exist_user(connection, user))
		return -1;

	state = mysql_query(connection, s);

	if (state != 0) {
		printf("%s\n", mysql_error(connection));
		mysql_close(connection);
		return -1;
	}

	mysql_close(connection);
	return 0;

}

int clear_notify(char *notify_user)
{
	int state;

	MYSQL *connection;
	MYSQL_RES *result;
	MYSQL_ROW row;
	char s[100];

	sprintf(s,
		"DELETE FROM notify WHERE notify_user='%s'", notify_user);

//      printf("%s\n",s);

	connection = mysql_real_connect(&mysql, MYSQL_SERVER, MYSQL_USER, MYSQL_PASSWD, "gnomemsg", 0, 0, 0);
	state = mysql_query(connection, s);

	if (state != 0) {
		printf("%s\n", mysql_error(connection));
		mysql_close(connection);
		return -1;
	}

	mysql_close(connection);
	return 1;

}

int store_mesg(msg_item *item)
{

	int state;

	MYSQL *connection;
	MYSQL_RES *result;
	MYSQL_ROW row;
	char *s;
	msg_mesg_dated *msg;
	msg_task *task;
	my_ulonglong id;
	char *mesg;

	connection = mysql_real_connect(&mysql, MYSQL_SERVER, MYSQL_USER, MYSQL_PASSWD, "gnomemsg", 0, 0, 0);

	switch(item->type) {

		case MSG_MESG:
			
			msg=(msg_mesg_dated *)item->data;
			if(!exist_user(connection, msg->hdr.user))
				return -1;

			s=malloc(400+msg->hdr.length);
			sprintf(s,"INSERT INTO offline_store (user, type, id) VALUES('%s',%d,NULL)",msg->hdr.user,MSG_MESG);
//			printf("%s\n",s);

			state = mysql_query(connection, s);

			if (state != 0) {
				printf("%s\n", mysql_error(connection));
				mysql_close(connection);
				return -1;
			}

			id=mysql_insert_id(connection);
			mesg=(char *) malloc(msg->hdr.length*2 +1);
			mysql_escape_string(mesg, msg->mesg, msg->hdr.length);

			sprintf(s,"INSERT INTO messages (user, subject, message, date, id) VALUES('%s','%s','%s','%d-%d-%d %d:%d:%d',%ld)", client.login, msg->hdr.subject, mesg, msg->hdr.date.year, msg->hdr.date.month, msg->hdr.date.day,msg->hdr.date.hour,msg->hdr.date.min,msg->hdr.date.sec,id);

			break;
	}

//	printf("%s\n",s);

	state = mysql_query(connection, s);

	if (state != 0) {
		printf("%s\n", mysql_error(connection));
		free(s);
		mysql_close(connection);
		return -1;
	}

	mysql_close(connection);
	free(s);
	return 0;

}

item_list *get_offline_msgs()
{

	item_list *list;
	item_list *ptr;
	msg_item *item;
	msg_mesg_dated *mesg_msg;
	char *date;

	int state;
	char s[1000];
	int count;

	MYSQL *connection;
	MYSQL_RES *result;
	MYSQL_RES *result2;
	MYSQL_ROW row;
	my_ulonglong id;

	
	sprintf(s,"SELECT id, type FROM offline_store WHERE user='%s'", client.login);

	connection = mysql_real_connect(&mysql, MYSQL_SERVER, MYSQL_USER, MYSQL_PASSWD, "gnomemsg", 0, 0, 0);
	state = mysql_query(connection, s);

	if (state != 0) {
		printf("%s\n", mysql_error(connection));
		mysql_close(connection);
		return NULL;
	}

	result=mysql_store_result(connection);
	count=mysql_num_rows(result);
	
	if(count == 0) {
		mysql_close(connection);
		return NULL;
	}

	list=(item_list *) malloc(sizeof(item_list));
	ptr=list;

	while(count--) {
		
		row=mysql_fetch_row(result);

		id=strtoul(row[0],NULL,10);
		item=&list->item;
		item->type=atoi(row[1]);

		sprintf(s,"SELECT user, subject, date, message FROM messages WHERE id=%ld", id);

		state=mysql_query(connection,s);
		result2=mysql_store_result(connection);
		
		row=mysql_fetch_row(result2);

		mesg_msg=(msg_mesg_dated *)malloc(sizeof(msg_mesg_dated));
		strcpy(mesg_msg->hdr.user,row[0]);
		strcpy(mesg_msg->hdr.subject, row[1]);
		date=row[2];
		
		mesg_msg->hdr.date.year=strtol(date, &date, 10);
		mesg_msg->hdr.date.month=strtol(date, &date, 10);
		mesg_msg->hdr.date.day=strtol(date, &date, 10);
		mesg_msg->hdr.date.hour=strtol(date, &date, 10);
		mesg_msg->hdr.date.min=strtol(date, &date, 10);
		mesg_msg->hdr.date.sec=strtol(date, &date, 10);

		mesg_msg->mesg=strdup(row[3]);
		mesg_msg->hdr.length=strlen(row[3]);

		item->data=mesg_msg;

		if(count) {
			list->next=(struct item_list *)malloc(sizeof(item_list));
			list=(item_list *)list->next;
		}
	}

	list->next=NULL;

	mysql_close(connection);
	return (ptr);

}

int del_offline_msgs(void)
{

	int state;
	char s[100];
	char *table;
	int count;
	char type;

	MYSQL *connection;
	MYSQL_RES *result;
	MYSQL_ROW row;
	my_ulonglong id;
	
	sprintf(s,"SELECT id, type FROM offline_store WHERE user='%s'", client.login);

	connection = mysql_real_connect(&mysql, MYSQL_SERVER, MYSQL_USER, MYSQL_PASSWD, "gnomemsg", 0, 0, 0);
	state = mysql_query(connection, s);

	if (state != 0) {
		printf("%s\n", mysql_error(connection));
		mysql_close(connection);
		return -1;
	}

	result=mysql_store_result(connection);
	count=mysql_num_rows(result);
	
	if(count == 0) {
		mysql_close(connection);
		return -1;
	}

	while(count--) {
		
		row=mysql_fetch_row(result);

		id=strtoul(row[0],NULL,10);
		type=atoi(row[1]);

		switch(type) {

			case MSG_MESG:

				table="messages";
				break;

			case MSG_TASK:

				table="tasks";
				break;
		}

		sprintf(s, "DELETE FROM %s WHERE id = %ld", table, id);
		state=mysql_query(connection,s);

		sprintf(s, "DELETE FROM offline_store WHERE id = %ld", id);
		state=mysql_query(connection,s);
	}

	mysql_close(connection);

	return 0;
}

int exist_user(MYSQL *connection, char *login)
{
	int state;

	MYSQL_RES *result;
	char s[100];

	sprintf(s, "SELECT login_id FROM users where login_id='%s'", login);

//      printf("%s\n",s);
	state = mysql_query(connection, s);

	if (state != 0) {
		printf("%s\n", mysql_error(connection));
		mysql_close(connection);
		return 0;
	}

	result = mysql_store_result(connection);

	if (mysql_num_rows(result) == 0) {
		printf("NULL result.\n");
		mysql_close(connection);
		return 0;
	}

	return 1;

}
