#ifndef SERVER_DEFS_H
#define SERVER_DEFS_H

#define MSG_LOGIN	1
#define MSG_LOGOUT	2
#define MSG_UINFO	3
#define MSG_TINFO	4
#define MSG_FINTASK	5
#define MSG_TASK	6
#define MSG_ERR		7
#define MSG_ACK		8
#define MSG_QUSER	9
#define MSG_NOUSER	10
#define MSG_NOLOGIN	11
#define MSG_EOF		12
#define MSG_STATUS	13
#define MSG_CONTACT	14
#define MSG_MESG	15
#define MSG_NOTIFY	16
#define MSG_CHGPASS	17
#define MSG_RETRMSGS	18

#define SIZE_ULEN	20

#define SEARCH_LOGIN	1
#define SEARCH_NAME	1 << 1
#define SEARCH_AGE	1 << 2
#define SEARCH_SEX	1 << 3
#define SEARCH_DESG	1 << 4
#define SEARCH_DEPT	1 << 5	
#define SEARCH_EXPT	1 << 6
#define SEARCH_STATUS	1 << 7

#define NUM_STATUS 4

#define STATUS_OFFLINE 	0
#define STATUS_ONLINE	1
#define STATUS_AWAY	2
#define STATUS_NA	3

#define SERVER_PORT	8180

typedef struct {
	unsigned char hour;
	unsigned char min;
	unsigned char sec;
	unsigned char day;
	unsigned char month;
	unsigned int year;
} __attribute__ ((packed)) date_type;

typedef struct {

	char login[20];
	char passwd[20];
	char status;
	unsigned short int port;
} __attribute__ ((packed)) msg_login;

typedef struct {

	char login[20];
	char name[20];
	char age;
	char sex;
	char desg[20];
	char dept[20];
	char expt[20];
	char status;

} __attribute__ ((packed)) uinfo;

typedef struct {
	char mask;
	uinfo info;
} __attribute__ ((packed)) msg_uinfo;

typedef struct {
	char login[20];
	unsigned long int ip;
	unsigned short int port;
	char status;
} __attribute__ ((packed)) client_info;

typedef struct {
	long int id;
} __attribute__ ((packed)) msg_fintask;

typedef struct {
	unsigned long int ip;
	unsigned short int port;
	char status;
} __attribute__ ((packed)) msg_quser;


typedef struct {
	char user[SIZE_ULEN];
	char subject[20];
	int length;
} __attribute__ ((packed)) msg_mesg_hdr;

typedef struct {
	char user[SIZE_ULEN];
	char subject[20];
	int length;
	date_type date;
} __attribute__ ((packed)) msg_mesg_hdr_dated;

typedef struct {
	msg_mesg_hdr hdr;
	char *mesg;
} __attribute__ ((packed)) msg_mesg;

typedef struct {
	msg_mesg_hdr_dated hdr;
	char *mesg;
} __attribute__ ((packed)) msg_mesg_dated;

typedef struct {

	long int id;
	char subject[20];
	date_type assign;
	date_type finish;
	char user[20];
	char priority;
	char assignee[20];
	char status;
	unsigned int length;
} __attribute__ ((packed)) msg_task_hdr;

typedef struct {
	msg_task_hdr hdr;
	char *task;
} __attribute__ ((packed)) msg_task;

typedef struct {
	uinfo info;
	struct list_uinfo *next;
} list_uinfo;


typedef struct {
	char type;
	void *data;
} msg_item;

typedef struct {
	msg_item item;
	struct item_list *next;
} item_list;

typedef struct {
	client_info client;
	struct list_notify *next;
} list_notify;

#endif
